
apiVersion: batch/v1
kind: Job
metadata:
  name: RELEASE-NAME-cacerts
  annotations:
    helm.sh/hook: pre-install,pre-upgrade
    helm.sh/hook-weight: "100"
    helm.sh/hook-delete-policy: before-hook-creation,hook-succeeded
spec:
  backoffLimit: 0
  template:
    spec:
      restartPolicy: Never
      serviceAccountName: RELEASE-NAME-cacerts
      initContainers:
      - name: build
        image: openjdk:19-alpine
        command:
        - sh
        - -c
        - |
          set -eux
          reset=true
          if ${reset}; then
            find /etc/ssl/ -name "*.pem" | xargs -r rm -fv
            find /etc/ssl/ -name "*.crt" | xargs -r rm -fv
            find /usr/share/ca-certificates/ /etc/ssl/certs/ -not -type d | xargs -r rm -fv
            > /etc/ca-certificates.conf
          fi
          update-ca-certificates
          install /etc/ssl/certs/java/cacerts /data/cacerts.jks
          install /etc/ssl/certs/ca-certificates.crt /data/cacerts.pem
        volumeMounts:
        - mountPath: /data
          name: data
        - mountPath: /usr/local/share/ca-certificates
          name: cacerts
      containers:
      - name: deploy
        image: bitnami/kubectl
        env:
        - name: name
          value: RELEASE-NAME-cacerts
        command:
        - sh
        - -c
        - |
          set -eux

          create=false
          update=false

          found=$(kubectl get configmap $name -o name --ignore-not-found | wc -l) || exit 1

          [ "$found" = "0" ] && create=true || update=true

          ${create} \
          && kubectl create configmap $name \
            --from-file=cacerts.pem=/data/cacerts.pem \
            --from-file=cacerts.jks=/data/cacerts.jks \
          && patch="
            metadata:
              annotations: 
                {}
          " \
          && echo "$patch" > /tmp/patch.yaml \
          && kubectl patch configmap $name --patch-file /tmp/patch.yaml \
          && exit 0

          ${update} \
          && pem="$(cat /data/cacerts.pem)" \
          && jks="$(cat /data/cacerts.jks | base64 -w0)" \
          && patch="
            metadata:
              annotations: 
                {}
            data:
              cacerts.pem: | $(echo; echo "$pem" | sed 's/^ */      /')
            binaryData:
              cacerts.jks: ${jks}
          " \
          && echo "$patch" > /tmp/patch.yaml \
          && kubectl patch configmap $name --patch-file /tmp/patch.yaml \
          && exit 0

          exit 1


        volumeMounts:
        - mountPath: /data
          name: data
      volumes:
      - name: data
        emptyDir:
          medium: Memory
      - name: cacerts
        configMap:
          name: RELEASE-NAME-cacerts-deploy
---
apiVersion: v1
kind: ConfigMap
metadata:
  name: RELEASE-NAME-cacerts-deploy
  annotations:
    helm.sh/hook: pre-install,pre-upgrade
    helm.sh/hook-weight: "90"
    helm.sh/hook-delete-policy: before-hook-creation,hook-succeeded
data:
  {}
---
---
apiVersion: v1
kind: ServiceAccount
metadata:
  name: RELEASE-NAME-cacerts
  annotations:
    helm.sh/hook: pre-install,pre-upgrade
    helm.sh/hook-weight: "90"
    helm.sh/hook-delete-policy: before-hook-creation,hook-succeeded
---
apiVersion: rbac.authorization.k8s.io/v1
kind: Role
metadata:
  name: RELEASE-NAME-cacerts
  annotations:
    helm.sh/hook: pre-install,pre-upgrade
    helm.sh/hook-weight: "90"
    helm.sh/hook-delete-policy: before-hook-creation,hook-succeeded
rules:
- apiGroups: ["*"]
  resources: [ configmaps ]
  verbs: ["*"]
---
apiVersion: rbac.authorization.k8s.io/v1
kind: RoleBinding
metadata:
  name: RELEASE-NAME-cacerts
  annotations:
    helm.sh/hook: pre-install,pre-upgrade
    helm.sh/hook-weight: "90"
    helm.sh/hook-delete-policy: before-hook-creation,hook-succeeded
roleRef:
  apiGroup: rbac.authorization.k8s.io
  kind: Role
  name: RELEASE-NAME-cacerts
subjects:
- kind: ServiceAccount
  name: RELEASE-NAME-cacerts
